var KarmaSendForm = function() {
	var form = $(this);
	var args = {};
	var destination = form.find("input[@name=js_destination]").val();
        var karma_url=KarmaBasePath + 'simple_karma/handle';

	if (  destination ) {
		top.location = KarmaBasePath + KarmaLoginPage + '?destination=' + destination;
		return false;
	}
	else {
		args.karma_vote 	= form.find("input[@name=karma_vote]").val()||form.find("select").val();
		args.oid 					= form.find("input[@name=oid]").val();
		args.otype 				= form.find("input[@name=otype]").val();
		args.form_type 		= 'ajax';
		form.addClass("KarmaSending");
		$.ajax({
			data		: args,
			url			: karma_url,
			type		: 'get',
			dataType: 'json',
			success	: function(json){
				var ts;
				for(var x in json) {args[x] = json[x];}
				if (json.error) {
					form.find(".tmpClicked").removeClass("tmpClicked");
					alert(json.error);
				} else {
					KarmaStripForm(form,args);
					form.addClass("KarmaSuccess");
					form.find("label").removeClass("KarmaClicked");
					form.find(".tmpClicked").addClass("KarmaClicked").removeClass("tmpClicked");
				}
			},
			error : function(xhr,msg){
				form.find(".tmpClicked").removeClass("tmpClicked");
				if (xhr.status==404||!msg) {
					alert("Karma Error: Communication (0)");
				} else {
					alert("Karma Error: "+msg);
				}
			},
			complete: function(xhr,stat) {
				(function(form,args){
					window.setTimeout(function(){
						form.removeClass("KarmaSending");
					},2000);
				})(form,args);
			}
		});
		return false;
	}
}

var KarmaStripForm  = function(form,args) {
	switch(form.find("input[@name=form_style]").val()) {
		case "1":
		case "2":
			if (KarmaOnlyOneVote) {
				form.find("select").attr("disabled","disabled");
			}
			break;
		case "3":
		case "4":
			if (KarmaOnlyOneVote) {
				form.find("label").removeClass("KarmaClickable").addClass("KarmaNotClickable").click(function(){return false;});
			}
			break;
	}
	var fid = form.attr("id");
	if ( args.karma_aggregate != "Undefined") {
		for ( var prefix in ( { 'w': 1, 'x': 1, 'y': 1, 'z': 1} ) ) {
			var did = prefix + args.oid;
			$("#" + did + " span.KarmaScore").text(args.karma_aggregate);
			var did = prefix + args.oid;
			if ( did != fid ) {
				$("#" + did + " *").attr("disabled", "true");
				$("#" + did + " label").removeClass("KarmaClickable").addClass("KarmaNotClickable").unbind('click');
			}
		}
	}
 
};

var KarmaRenderForm = function() {
	var form   = $(this);
	var submit = form.find("input[@type=submit]");

  form.css('visibility', 'Visible');
	submit.hide();

	switch(form.find("input[@name=form_style]").val()) {
		case '1':
		case '2':
			if (submit.attr("disabled")) {
				form.find("select").attr("disabled","true");
				form.find("label").addClass("KarmaNotClickable");
			} else {
				form.find("select").change(function(){form.submit();});
			}
			break;
		case '3':
		case '4':
			form.find("input[@name=karma_vote]").each(function(){
				$(this).after('<input type="hidden" name="'+this.id+'" value="'+$(this).val()+'"/>');
				$(this).remove();
			});
			form.append('<input name="karma_vote" type="hidden" value="0"/>');
   			form.find("label:contains(UP)").html("");
   			form.find("label:contains(DOWN)").html("");
			if (submit.attr("disabled")) {
				form.find("label").addClass("KarmaNotClickable");
			} else {
				form.find("label").addClass("KarmaClickable").click(function(){
					$(this).addClass("tmpClicked");
					form.find("input[@name=karma_vote]").val(form.find("input[@name="+$(this).attr("for")+"]").val());
					form.submit();
				});
			}
			break;
	}
}

$(function(){
		$("form.KarmaForm").submit(KarmaSendForm).each(KarmaRenderForm);
});
